// Stupid MSVC8
#define _USE_MATH_DEFINES
#include <math.h>
#include "spamtac.h"
#include "game.h"
#include "dirty.h"
#include "spam.h"
#include "banana.h"
#include "timer.h"

BITMAP *spam, *banana, *bg;
static volatile unsigned int game_time;

// Current player info
int player_score[4] = {0,0,0,0}, cur_player = 0;
int turret_x;
bool firing;
int health;
float time_left;

Timer timer;

PALETTE game_palette = {
	// Trans/Back, cursor, banana, letter
	{ 0, 0, 0}, {63,63,63}, {63,63, 0}, {63,63,63},
	// letter outline, turret, sky, clouds
	{63, 0, 0}, {31,31,63}, { 0, 0,63}, {60,60,60},
	// In case I decide to draw a real background
	// tree, tree detail, leaves, leaves detail
	{ 0, 0, 0}, { 0, 0, 0}, { 0, 0, 0}, { 0, 0, 0},
	// sand, sand detail, insane meter
	{61,53,29}, {41,31,21}, {31,31,63}, {63,63,63}
}, insane_palette = {
	// Trans/Back, cursor, banana, letter
	{ 0, 0, 0}, {63,63,63}, {25,48,34}, {57,21, 8},
	// letter outline, turret, sky, clouds
	{45,15,57}, {24,15,49}, {15,51,27}, {49,28,19},
	// In case I decide to draw a real background
	// tree, tree detail, leaves, leaves detail
	{49,24,37}, {57,12,37}, {45,37,34}, {48,35,63},
	// sand, sand detail, insane meter, text
	{27,43,61}, {45,37,63}, {31,31,63}, {63,63,63}
}, temp_palette;

static void game_timer(void) {
	game_time++;
}
END_OF_STATIC_FUNCTION(game_timer);

static void process_events(void) {
	process_spam();
	process_bananas();

	// Process Turret stuff
	turret_x = mouse_x;
	if (!firing && mouse_b & 1) {
		add_banana(turret_x - banana->w/2, 570);
		play_sample((SAMPLE*)data[SHOOT_WAV].dat, 255, 128, 1000 + (rand() % 200 - 100), 0);
		firing = true;
	}
	if (!(mouse_b & 1)) {
		firing = false;
	}

}

static void draw_screen(BITMAP *bmp) {
	scare_mouse();
	clear_dirty(bmp, bg); // Need to test hack for background image

	draw_spam(bmp);
	draw_bananas(bmp);

	// Draw Turret
	rectfill(bmp, turret_x - banana->w/2 - 2, 580, turret_x + banana->w/2 + 2, 600, 5);
	dirty_rectangle(turret_x - banana->w/2 - 2, 580, turret_x + banana->w/2 + 2, 600);

	// Draw Health
	rectfill(bmp, 780, 0, 800, 102, 0);
	rectfill(bmp, 781, 101-health*5, 799, 101, 14);
	dirty_rectangle(780, 0, 20, 102);

	draw_dirty(bmp);
	textprintf_ex(screen, font, 9, 10, 15, 0, "Time left %3d", (int)(time_left - timer.GetStopwatchTimeSec()));
	unscare_mouse();
}

void hit_player(void) {
	health--;
}

void spam_hit(void) {
	player_score[cur_player]++;
}

void player_ready() {
	scare_mouse();
	clear_bitmap(screen);
	// Player get ready!
	textout_ex(screen, font, "Press any key to start", 200, 300, 3, 0);
	unscare_mouse();
	clear_keybuf();
	readkey();
	// Let the spam start!
}

void play_game(void) {
	bool snapshot[4] = {true, true, true, true};
	BITMAP *buffer;
	firing = false;
	turret_x = mouse_x;
	unsigned int last_update_time;

	clear_bitmap(screen);

	buffer = create_bitmap(800, 600);
	if (!buffer)
		return; // assume if this works, other works as well
	clear_to_color(buffer, 6);
	bg = create_bitmap(800, 600);
	clear_to_color(bg, 6);
	// Draw clouds (7)
	for (int i = 0; i < 20; i++) {
		int x, y, rx, ry;
		x = rand() % 800;
		y = rand() % 200;
		rx = (rand() % 7) + 13;
		ry = (rand() % 7) + 3;
		ellipsefill(bg, x, y, rx, ry, 7);
	}

	// Draw sand (12,13)
	rectfill(bg, 0, 590, 799, 599, 12);
	for (int i = 0; i < 1000; i++) {
		int x, y;
		x = rand() % 800;
		y = (rand()%10)+590;
		putpixel(bg, x, y, 13);
	}

	// Draw tree (bark 8,9, leaves 10,11)

	blit(bg, buffer, 0, 0, 0, 0, 800, 600);
	dirty_rectangle(0, 0, 800, 600);

	// Make spam
	spam = create_bitmap(32, 16);
	rectfill(spam, 0, 0, 31, 15, 3);
	rect(spam, 0, 0, 31, 15, 4);
	line(spam, 0, 0, 15, 8, 4);
	line(spam, 15, 8, 31, 0, 4);

	// Make banana bullet
	banana = create_bitmap(16, 16);
	clear_bitmap(banana);
	arc(banana, 7, 9, itofix(0), itofix(129), 7, 2);
	arc(banana, 7, 15, itofix(0), itofix(129), 10, 2);
	floodfill(banana, 7, 3, 2);

	// Draw other stuff

	LOCK_VARIABLE(game_time);
	LOCK_FUNCTION(game_timer);
	install_int_ex(game_timer, BPS_TO_TIMER(60));

	switch (time_limit) {
		case TIME_30SEC:
			time_left = 30;
			break;
		case TIME_1MIN:
			time_left = 60;
			break;
		case TIME_2MIN:
			time_left = 120;
			break;
		case TIME_3MIN:
			time_left = 180;
			break;
		case TIME_5MIN:
			time_left = 300;
			break;
	}

	while (num_players > cur_player) {
		bool running = true;
		int insane_level = 64;
		set_palette(game_palette);
		player_ready();
		blit(bg, screen, 0, 0, 0, 0, 800, 600);
		init_spam();
		clear_bananas();
		game_time = last_update_time = 0;
		timer.StartStopwatch();
		health = 20;
		while (running) {
			bool updated = false;

			while (last_update_time < game_time) {
				process_events();
				last_update_time++;
				updated = true;
				if (!(last_update_time % 30)) {
					add_spam();
				}
				insane_level = 32 - (int)(((health)/20.0)*64)/2;
				insane_level = insane_level + (int)(insane_level*sin((game_time*5)*M_PI/180.0));
				insane_level = 64 - insane_level;
			}
			if (time_left < timer.GetStopwatchTimeSec() || health <= 0) {
				running = false;
			}

			if (updated) {
				fade_interpolate(insane_palette, game_palette, temp_palette, insane_level, 2, 25);
				draw_screen(buffer);
				set_palette_range(temp_palette, 2, 25, 1);/**/
			}
			else
				rest(1);

			if (keypressed()) {
				if ((readkey() >> 8) == KEY_ESC) {
					running = false;
					num_players = -1;
				}
			}
		}
		if (num_players != -1) {
			// get ready to process next player
			cur_player++;
		}
	}
	set_palette(game_palette);
	if (num_players != -1) {
		scare_mouse();
		clear_bitmap(screen);
		textout_ex(screen, font, "Player scores", 200, 300, 3, 0);
		for (cur_player = 0; cur_player < num_players; cur_player++) {
			textprintf_ex(screen, font, 220, 310 + (cur_player * 10), 3, 0, "Player %d: %d", cur_player + 1, player_score[cur_player]);
		}
		clear_keybuf();
		readkey();
		unscare_mouse();
	}

	destroy_bitmap(bg);
	destroy_bitmap(buffer);
	destroy_bitmap(spam);
	destroy_bitmap(banana);
}
